# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

from ...core.datetime_utils import serialize_datetime
from ...core.pydantic_utilities import pydantic_v1
from .business_profile_request import BusinessProfileRequest
from .individual_profile_request import IndividualProfileRequest


class ProfileRequest(pydantic_v1.BaseModel):
    business: typing.Optional[BusinessProfileRequest] = pydantic_v1.Field(default=None)
    """
    If this entity is a business, set this field
    """

    individual: typing.Optional[IndividualProfileRequest] = pydantic_v1.Field(default=None)
    """
    If this entity is a individual, set this field
    """

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().dict(**kwargs_with_defaults)

    class Config:
        frozen = True
        smart_union = True
        extra = pydantic_v1.Extra.allow
        json_encoders = {dt.datetime: serialize_datetime}
